#!/usr/bin/perl
$| = 1;
use strict;
use FindBin;
use lib $FindBin::Bin;
 if ($ENV{'WINDIR'} ne undef) { chdir($FindBin::Bin); }

my $checkdomain    = "secure.authorize.net";
my $checkurl       = "/gateway/transact.dll";
my $passed         = 1;
my $islwp          = 0;
my $isnetssl       = 0;
my $isnetssleay    = 0;
my $netsslworks    = 0;
my $netssleayworks = 0;

print "Content-type: text/html\n\n";
print "<html><head><title>AutoCharge Site Test</title></head>\n";
print "<body>\n";
print "<p><b>AutoCharge site testing results:</b></p>\n";

print "Perl version : ";
 if(eval "require 5.003") { print "<b>compatible</b><br>\n"; }
 else { print "<b>incompatible</b><br>\n"; $passed = 0; }

print "Perl module LWP::UserAgent : ";
 if(eval "require LWP::UserAgent") { print "<b>found</b><br>\n"; $islwp = 1; }
 else { print "<b>not found</b><br>\n"; }

print "Perl module Net::SSL : ";
 if(eval "require Net::SSL") { print "<b>found</b><br>\n"; $isnetssl = 1; }
 else { print "<b>not found</b><br>\n"; }

print "Perl module Net::SSLeay : ";
 if(eval "require Net::SSLeay") { print "<b>found</b><br>\n"; $isnetssleay = 1; }
 else { print "<b>not found</b><br>\n"; }


 if($isnetssl == 1 && $islwp == 1)
 {
  print "Trying module Net::SSL : ";
  my $ua  = new LWP::UserAgent;
  my $req = new HTTP::Request('POST','https://'.$checkdomain.$checkurl);
  my $res = $ua->request($req);
   if($res->code == 200) { print "<b>success</b><br>\n"; $netsslworks = 1; }
   else { print "<b>failure</b><br>\n"; }
 }

 if($isnetssleay == 1)
 {
  print "Trying module Net::SSLeay : ";
  my ($page,$response,%headers) = Net::SSLeay::get_https($checkdomain,443,$checkurl);
   if($response =~ /200/) { print "<b>success</b><br>\n"; $netssleayworks = 1; }
   else { print "<b>failure</b><br>\n"; }
 }

 if($netssleayworks == 0 && $netsslworks == 0) { $passed = 0; }

print "<p><b>Summary:</b></p>\n";
 if($passed == 0)
 { print "Your server <b>is not prepared</b> to run AutoCharge<br>" .
         "please ask your ISP to install/configure required Perl libraries<br>\n"; }
 else
 { print "Your server <b>is ready to run</b> AutoCharge<br><br>" .
         "Proceed to <a href=\"http://www.eastwright.com/internet/autocharge/order.html\">AutoCharge ordering</a>\n"; }
 
print "</body></html>\n";

